import sys
import os
import re
import common
forge = sys.modules["forge"]

def setup(module):
	for boost_source in forge.boost_sources:
		if not os.path.exists(boost_source[2]) or not os.path.exists(boost_source[3]):
			forge.color_on(0, forge.BLUE)
			sys.stdout.write(" -" + boost_source[0])
			forge.color_off()
			continue

		boost_lib = common.find_boost_lib(boost_source[1], boost_source[3], 'thread')
		if boost_lib == '':
			forge.color_on(0, forge.BLUE)
			sys.stdout.write(" -" + boost_source[0])
			forge.color_off()
			continue

		if boost_source[0] == "":
			sys.stdout.write(" /")
		else:
			sys.stdout.write(" " + boost_source[0])

#		sys.stdout.write(" " + boost_lib)

		srcList = [	"boostthread.pmh",
					"boostthreadDL" ]

		variant = boost_source[0]
		if variant != "":
			variantPath = module.modPath + '/' + variant
			if os.path.lexists(variantPath) == 0:
				os.symlink('.', variantPath)

			srcListVariant = []
			for src in srcList:
				srcListVariant += [ variant + '/' + src ]
			srcList = srcListVariant

		dllname = "fexBoostThread" + variant

		dll = module.DLL( dllname, srcList )

		alt_cxx = boost_source[4]

		if alt_cxx != '':
			dll.cxx = alt_cxx

		for src in srcList:
			relativePath = forge.RelativePath(forge.rootPath,module.modPath)
			modObjPath = os.path.join(forge.objPath, relativePath)
			objName = modObjPath + '/' + src
			if re.compile(r'(.*)\.pmh$').match(src):
				objName += '.gch'
			else:
				objName += forge.objsuf
			srcTarget = forge.FindTarget(objName)
			srcTarget.includemap = { 'boostthread' : boost_source[2] }

			if alt_cxx != '':
				srcTarget.cxx = alt_cxx

		dll.linkmap = { "boostthread" :
				"-L" + boost_source[3] + ' -l' + boost_lib }
		if not re.compile(".*houdini.*").match(boost_source[3]):
			dll.linkmap["boostthread"] += ' -Xlinker -rpath ' + boost_source[3]

		deplibs = [ "fePlatformLib" ]

		forge.deps( [ dllname + "Lib" ], deplibs )
